/**
 * Copyright IBM Corp. 2016, 2018
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import React from 'react';
import ToggleNext from './next/Toggle';
import ToggleClassic from './Toggle';
import { useFeatureFlag } from '../FeatureFlags';

function Toggle(props) {
  var enabled = useFeatureFlag('enable-v11-release');

  if (enabled) {
    return /*#__PURE__*/React.createElement(ToggleNext, props);
  }

  return /*#__PURE__*/React.createElement(ToggleClassic, props);
}

export { default as ToggleSkeleton } from './Toggle.Skeleton';
export default Toggle;