"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CustomItems = exports.Default = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _addonActions = require("@storybook/addon-actions");

var _addonKnobs = require("@storybook/addon-knobs");

var _OverflowMenu = _interopRequireDefault(require("../OverflowMenu"));

var _OverflowMenuItem = _interopRequireDefault(require("../OverflowMenuItem"));

var _Button = _interopRequireDefault(require("../Button"));

var _Link = _interopRequireDefault(require("../Link"));

var _Card = _interopRequireDefault(require("./Card"));

var _CardFooter = _interopRequireDefault(require("../CardFooter"));

var _CardContent = _interopRequireDefault(require("../CardContent"));

var _CardContentItem = _interopRequireDefault(require("../CardContentItem"));

var _Card2 = _interopRequireDefault(require("./Card.mdx"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable no-console */
var props = {
  default: function _default() {
    return {
      onClick: (0, _addonActions.action)('onClick'),
      onFocus: (0, _addonActions.action)('onFocus'),
      className: (0, _addonKnobs.text)('class name', 'some-class'),
      description: (0, _addonKnobs.text)('description', 'description')
    };
  }
};
var _default2 = {
  title: 'RocketPatterns/Card',
  decorators: [_addonKnobs.withKnobs],
  parameters: {
    component: _Card.default,
    docs: {
      page: _Card2.default
    }
  }
};
exports.default = _default2;

var Default = function Default() {
  return /*#__PURE__*/_react.default.createElement(_Card.default, props.default(), /*#__PURE__*/_react.default.createElement(_CardContent.default, {
    cardTitle: "Card Name",
    cardInfo: ['Lorem ipsum sit amet, consectetur adipisicing elit, sed do eiusmod tempor']
    /* eslint-disable react/jsx-key, jsx-a11y/anchor-is-valid */
    ,
    cardLink: [/*#__PURE__*/_react.default.createElement("a", {
      href: "#",
      className: "bx--link bx--card-footer__link"
    }, "Link")]
    /* eslint-enable react/jsx-key, jsx-a11y/anchor-is-valid */

  }, /*#__PURE__*/_react.default.createElement(_OverflowMenu.default, null, /*#__PURE__*/_react.default.createElement(_OverflowMenuItem.default, {
    itemText: "Stop App"
  }), /*#__PURE__*/_react.default.createElement(_OverflowMenuItem.default, {
    itemText: "Restart App"
  }), /*#__PURE__*/_react.default.createElement(_OverflowMenuItem.default, {
    itemText: "Rename App"
  }), /*#__PURE__*/_react.default.createElement(_OverflowMenuItem.default, {
    itemText: "Delete App",
    hasDivider: true
  }))), /*#__PURE__*/_react.default.createElement(_CardFooter.default, null, /*#__PURE__*/_react.default.createElement(_Button.default, {
    size: "small",
    kind: "primary",
    style: {
      width: 10 + '%'
    }
  }, "Button"), /*#__PURE__*/_react.default.createElement(_Link.default, {
    href: "#",
    className: "bx--card-footer__link"
  }, "Link")));
};

exports.Default = Default;
Default.story = {
  name: 'Card'
};

var CustomItems = function CustomItems() {
  return /*#__PURE__*/_react.default.createElement(_Card.default, props.default(), /*#__PURE__*/_react.default.createElement(_CardContent.default, {
    cardTitle: "Card Name",
    cardInfo: ['Lorem ipsum sit amet, consectetur adipisicing elit, sed do eiusmod tempor']
    /* eslint-disable react/jsx-key, jsx-a11y/anchor-is-valid */
    ,
    cardLink: [/*#__PURE__*/_react.default.createElement("a", {
      href: "#",
      className: "bx--link bx--card-footer__link"
    }, "Link")],
    cardContentItems: [/*#__PURE__*/_react.default.createElement(_CardContentItem.default, {
      info: 'Lorem ipsum sit amet, consectetur adipisicing elit, sed do eiusmod tempor',
      maxWidth: '10rem'
    })]
    /* eslint-enable react/jsx-key, jsx-a11y/anchor-is-valid */

  }, /*#__PURE__*/_react.default.createElement(_OverflowMenu.default, null, /*#__PURE__*/_react.default.createElement(_OverflowMenuItem.default, {
    itemText: "Stop App"
  }), /*#__PURE__*/_react.default.createElement(_OverflowMenuItem.default, {
    itemText: "Restart App"
  }), /*#__PURE__*/_react.default.createElement(_OverflowMenuItem.default, {
    itemText: "Rename App"
  }), /*#__PURE__*/_react.default.createElement(_OverflowMenuItem.default, {
    itemText: "Delete App",
    hasDivider: true
  }))), /*#__PURE__*/_react.default.createElement(_CardFooter.default, null, /*#__PURE__*/_react.default.createElement(_Button.default, {
    size: "small",
    kind: "primary",
    style: {
      width: 10 + '%'
    }
  }, "Button"), /*#__PURE__*/_react.default.createElement(_Link.default, {
    href: "#",
    className: "bx--card-footer__link"
  }, "Link")));
};

exports.CustomItems = CustomItems;
CustomItems.story = {
  name: 'Card With Custom Items'
};